#include <stdio.h>
typedef enum {false,true} boolean;

void swap(int* xs,int i,int j){
  int tmp=xs[i];
  xs[i]=xs[j];
  xs[j]=tmp;
}

boolean bubble(int* xs,int i,boolean smaller(int,int)){
  boolean result = false;
  int j=0;
  for (;j<(i-1);j++)
    if (!smaller(xs[j],xs[j+1])){
      swap(xs,j,j+1);
      result=true;
    }
  return result;
}

void bubbleSort(int* xs, int length,boolean smaller(int,int)){
  boolean changed = true;
  for (;changed && length>1;length--) 
    changed=bubble(xs,length,smaller);
}

boolean le(int x,int y){return x<y;}
boolean ge(int x,int y){return x>y;}
boolean oddFirst(int x,int y){return x%2>y%2 || (x%2==y%2 && x<y);}


void printArray(int* xs,int length){
  int i=0;
  printf("[");
  for (;i<length;i++){
    printf("%i",xs[i]);
    if (i<length-1) printf(", ");
  }
  printf("]\n");
}

int main(){
  int xs [] = {321,43,43,5345,54,543,543,543,43,1,4,2};
  bubbleSort(xs,12,le);
  printArray(xs,12);
  bubbleSort(xs,12,ge);
  printArray(xs,12);
  bubbleSort(xs,12,oddFirst);
  printArray(xs,12);
  return 0;
}

