#ifndef COMPLEX_H__
#define COMPLEX_H__

typedef struct{
  double real;
  double imag;
} Complex;

void printComplex(Complex c);

Complex add(Complex x,Complex y);
Complex sub(Complex x,Complex y);
Complex mult(Complex x,Complex y);
Complex divC(Complex x,Complex y);
double norm(Complex x);
unsigned int schwelle(Complex c,double schwellwert);


Complex mapComplex(Complex c,double f(double x));
#endif

