#include "List.h"
#include <stdlib.h>
#include <stdio.h>

List newList(){return (List)malloc(sizeof (struct Liste));}

List nil(){
  List result=newList();
  result->tail=NULL;
  return result;
};

List cons(int x, List xs){
  List result=newList();
  result->head=x;
  result->tail=xs;
  return result;
};

bool isEmpty(List xs){
  return xs->tail==NULL;
};

void delete(List xs){
  if (!isEmpty(xs)) delete(xs->tail);
  free(xs);
}


