#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef struct {
  int x;
  int y;
} PunktStrukt;

typedef PunktStrukt* Punkt;

Punkt newPunkt(int x,int y){
  Punkt this = (Punkt)malloc(sizeof(PunktStrukt));
  this->x = x;
  this->y = y;
  return this;
}

void deletePunkt(Punkt this){
  free(this);
}

void printPunkt(Punkt this){
  printf("(%i,%i)\n",this->x,this->y);
}

double betrag(Punkt this){
  return sqrt(this->x*this->x+this->y*this->y);
}

void verschiebe(Punkt this,int deltaX,int deltaY){
  this->x += deltaX;
  this->y += deltaY;
}

int main(){
  Punkt p= newPunkt(17,4);
  printPunkt(p);
  printf("betrag: %f\n",betrag(p));
  verschiebe(p,2,4);
  printPunkt(p);
  deletePunkt(p);
  return 0;
}

