#include "ReadRoman.h"

int romanCharToInt(char c){
  switch (c){
    case 'I': return 1;
    case 'V': return 5;
    case 'X': return 10;
    case 'L': return 50;
    case 'C': return 100;
    case 'D': return 500;
    case 'M': return 1000;
  }
  return -1;
}

int romanToInt(char* roman){
  int result=0;
  int last=0;
  char* i;
  for (i=roman;*i != '\0';i++){
    int current=romanCharToInt(*i); 
    if (current>last) result = result-2*last;
    result=result+current;
    last=current;
  }  
  return result;
}

