#include <stdio.h>
#include <stdlib.h>
typedef enum {false,true} boolean;

void swap(int* xs,int i,int j){
  int tmp=xs[i];
  xs[i]=xs[j];
  xs[j]=tmp;
}

boolean bubble(int* xs,int i){
  boolean result = false;
  int j=0;
  for (;j<(i-1);j++){
    if (!xs[j]<xs[j+1]){
      swap(xs,j,j+1);
      result=true;
    }
  }
  return result;
}

void bubbleSort(int* xs, int length){
  boolean changed = true;
  for (;changed && length>1;length--) 
    changed=bubble(xs,length);
}

int main(){
  int xs [] = {321,43,43,5345,54,543,543,543,43,1,4,2};
  bubbleSort(xs,12);
  int i=0;
  for (;i<12;i++)printf("%i,",xs[i]);
  printf("\n");
  return 0;
}

