#include "Dialogue.h"
#include <stdlib.h>
#include "StringLength.h"

void reagiere(GtkObject* object){
  GtkDialogue* dialogue = (GtkDialogue*)object;
  char* eingabe = gtk_entry_get_text(dialogue->eingabe);
  char ausgabe [stringLaenge(eingabe)+1];
  dialogue->f(eingabe,ausgabe);
  gtk_label_set_text( dialogue->ausgabe,ausgabe);
}

void addToBox(GtkBox* box,GtkWidget* item){
  gtk_box_pack_start(box,GTK_WIDGET(item), FALSE, FALSE, 0);
}

GtkWidget* dialogue_new(void (*f)(char*,char*)){
  GtkDialogue* dialogue = (GtkDialogue*) malloc(sizeof(GtkDialogue));

  GtkVBox* tmp = GTK_VBOX(gtk_vbox_new (FALSE, 0));
  dialogue->super =  *tmp;
  gtk_widget_destroy(GTK_WIDGET(tmp));
    
  dialogue->f = f;
  dialogue->eingabe = (GtkEntry*)gtk_entry_new();
  addToBox(GTK_BOX(dialogue), GTK_WIDGET(dialogue->eingabe));

  dialogue->okKnopf = (GtkButton*)gtk_button_new_with_label("Run");
  addToBox(GTK_BOX(dialogue), GTK_WIDGET(dialogue->okKnopf));

  dialogue->ausgabe = (GtkLabel*)gtk_label_new("");
  addToBox(GTK_BOX(dialogue), GTK_WIDGET(dialogue->ausgabe));

  gtk_signal_connect_object
    (GTK_OBJECT(dialogue->okKnopf), "clicked"
    ,GTK_SIGNAL_FUNC(reagiere)    , GTK_OBJECT(dialogue));

  return GTK_WIDGET(dialogue);
}

