#include "PListUtil.h"

int length(PList xs){
  if (isEmpty(xs)) return 0;
  return 1+length(xs->tail);
}

PList copy(PList xs){
  if (isEmpty(xs)) return nil();
  return cons(xs->head,copy(xs->tail));
}

PList append(PList xs,PList ys){
  if (isEmpty(xs)) return copy(ys);
  return cons(xs->head,append(xs->tail,ys));
}

PList reverse(PList xs){
  PList result=nil();
  while (!isEmpty(xs)){
    result=cons(xs->head,result);
    xs=xs->tail;
  }
  return result;
}

PList map(Object f (Object),PList xs){
  if (isEmpty(xs)) return nil();
  return cons(f(xs->head),map(f,xs->tail));
}

void forEach(void f (Object),PList xs){
  for (;!isEmpty(xs);xs=xs->tail) f(xs->head);
}


