#include "PListUtil.h"
#include "Punkt.h"

#include <stdio.h>

void move(Punkt* this){
  this->x=2*this->x;
  this->y=2*this->y;
}

int main(){
  Punkt p1 = {0,0};
  Punkt p2 = {0,2};
  Punkt p3 = {2,2};
  Punkt p4 = {2,0};

  PList polygon=cons(&p1,cons(&p2,cons(&p3,cons(&p4,nil()))));

  printf("length(polygon)=$i\n",length(polygon));
  printf("polygon: [");  
  forEach(printPunkt,polygon);
  printf("]\n");

  PList pol2 = append(polygon,polygon);
  printf("append(polygon,polygon): [");    
  forEach(printPunkt,pol2);
  printf("]\n");

  PList pol3 = reverse(pol2);
  printf("reverse(pol2): [");  
  forEach(printPunkt,pol3);
  printf("]\n");

  map(move,pol3);
  printf("map(move,pol3): [");  
  forEach(printPunkt,pol3);
  printf("]\n");

  delete(polygon);
  delete(pol2);
  delete(pol3);

  return 0;
}



