#include <stdio.h>

typedef enum   {INT,STRING} TypeMarker;
typedef union  {int i;char * s;} stringOrInt;

typedef struct {TypeMarker type;stringOrInt v;} strOrInt;

strOrInt forInt(int i){
  strOrInt result;
  result.type=INT;
  result.v.i=i;
  return result;
}

strOrInt forString(char * s){
  strOrInt result;
  result.type=STRING;
  result.v.s=s;
  return result;
}

char * toString(strOrInt si){
  char* result;
  if (si.type==INT){
    sprintf(result,"%d",si.v.i);
  }else if (si.type==STRING){
    result=si.v.s;
  }
  return result;
}

int main(){
  strOrInt test = forString("hallo da draussen");
  printf("%s\n", toString(test));
  test = forInt(42);
  printf("%s\n", toString(test));
  return 0;
}

